<template lang="pug">
.related-items(
  :class="{ mobile: isMobile, portrait: isPortrait }"
  :style="{ visibility: (loading || !isEmpty) ? 'visible' : 'hidden' }"
)
  div(
    v-if="relatedItemsListShown"
    ref="list"
  )
    .preloader-items(v-if="loading")
      .animated-background(
        v-for="itemStyles in preloadingItems"
        :style="mainListItemStyles"
      )
    .list(
      v-else
      :style="{ 'justify-content': isShowExpander ? 'flex-start' : 'center' }"
    )
      template(v-if="activeItem && faceSelected && activeItem.swappedFacesData.total")
        .item.random-face(
          :style="mainListItemStyles"
          @click="swapRandomFace()"
        )
          .icon(v-html="$icons.crossing")
          div Random face
        .item.swapped-face(
          v-for="item in activeItem.swappedFacesData.faces.slice(0, 30)"
          :key="item.id"
          :style="mainListItemStyles"
          @click="swapFace(item)"
        )
          .hover(v-if="!isMobile")
            .icon(v-html="$icons.replace")
            div Replace
          img(:src="item.url")
      template(v-else-if="activeItem")
        .item(
          v-for="item in relatedToItemItems.items.slice(0, 30)"
          :key="item.id"
          :style="mainListItemStyles"
          @click="selectRelatedToItem(item)"
        )
          .hover(v-if="!isMobile")
            .icon(v-html="$icons.replace")
            div Replace
          img(:src="item.thumb")
      template(v-else)
        .item(
          v-for="item in (isDefaultBackgroundActive ? backgrounds : relatedToStageItems).slice(0, 30)"
          :key="item.id"
          :style="mainListItemStyles"
          @dragstart="dragStart(item, $event)"
          @click="selectRelatedToStage(item)"
          @touchstart = "handleTouchStart"
          @touchmove = "handleTouchMove"
          @touchend = "handleTouchEnd($event, item)"
        )
          img(:src="item.thumb")
  transition(name="fade")
    .alternatives-panel.panel(
      v-if="swappedFacesPanelExpanded"
      key="faces"
    )
      .stage
        .title swapped faces
        .snapshot
          img(:src="stagePreview")
          .shrink-button(
            v-if="!isMobile"
            v-tooltip:bottom="'Shrink panel'"
            v-html="$icons.menuArrowDown"
            @click="swappedFacesPanelExpanded = false"
          )
      .list-container
        .panel-list(v-app-scroll ref="scrollContainer")
          masonry(
            :cols="panelColumnsCount"
            gutter="4"
            ref="masonry"
          )
            .item.swapped-face(
              v-for="item in activeItem.swappedFacesData.faces"
              :key="item.id"
              :style="getItemStyle(item)"
              @click="swapFace(item)"
            )
              .hover(v-if="!isMobile")
                .icon(v-html="$icons.replace")
                div Replace
              img(:src="item.url")
          .load-button(v-show="showLoadButton")
            .background
            .text Load more
          .loader-container(v-show="itemsLoading")
            .loader
      .close-button(
        v-if="isMobile"
        v-html="$icons.close"
        @click="swappedFacesPanelExpanded = false"
      )
    .alternatives-panel.panel(
      v-else-if="relatedToItemPanelExpanded"
      key="alternatives"
    )
      .stage
        .title alternatives
        .snapshot
          img(:src="stagePreview")
          .shrink-button(
            v-if="!isMobile"
            v-tooltip:bottom="'Shrink panel'"
            v-html="$icons.menuArrowDown"
            @click="relatedToItemPanelExpanded = false"
          )
      .list-container
        .panel-list(v-app-scroll ref="scrollContainer")
          masonry(
            :cols="panelColumnsCount"
            gutter="4"
            ref="masonry"
          )
            .item(
              v-for="item in (isDefaultBackgroundActive ? backgrounds : relatedToItemItems.items)"
              :key="item.id"
              @click="selectRelatedToItem(item)"
              :style="getItemStyle(item)"
            )
              .hover(v-if="!isMobile")
                .icon(v-html="$icons.replace")
                div Replace
              img(:src="item.thumb")
          .load-button(v-show="showLoadButton")
            .background
            .text Load more
          .loader-container(v-show="itemsLoading")
            .loader
      .close-button(
        v-if="isMobile"
        v-html="$icons.close"
        @click="relatedToItemPanelExpanded = false"
      )
    .related-panel.panel(
      v-else-if="relatedToStagePanelExpanded"
      key="related"
      ref="relatedPanel"
    )
      .stage
        .title related
        .snapshot
          img(:src="stagePreview")
          .shrink-button(
            v-if="!isMobile"
            v-tooltip:bottom="'Shrink panel'"
            v-html="$icons.menuArrowDown"
            @click="shrinkRelatedToStagePanel"
          )
      .list-container(ref="relatedListContainer")
        .menu(
          :class="{ expanded: relatedPanelMenuExpanded, shrinked: !relatedPanelMenuExpanded, sticky: relatedPanelMenuIsSticky }"
          ref="relatedPanelMenu"
        )
          .menu-item(
            v-if="relatedModels.items.length"
            :class="{ active: relatedTabName === RELATED_TAB_MODELS, hidden: !relatedPanelMenuExpanded && relatedTabName != RELATED_TAB_MODELS && !isPortrait }"
            @click="chooseRelatedTab(RELATED_TAB_MODELS)"
          )
            span Models
            .expand-menu-button(
              v-if="isMobile && !relatedPanelMenuExpanded && !isPortrait"
              v-html="$icons.menuArrowDown"
            )
          .menu-item(
            v-if="relatedObjects.items.length"
            :class="{ active: relatedTabName === RELATED_TAB_OBJECTS, hidden: !relatedPanelMenuExpanded && relatedTabName != RELATED_TAB_OBJECTS && !isPortrait }"
            @click="chooseRelatedTab(RELATED_TAB_OBJECTS)"
          )
            span Objects
            .expand-menu-button(
              v-if="isMobile && !relatedPanelMenuExpanded && !isPortrait"
              v-html="$icons.menuArrowDown"
            )
          .menu-item(
            v-if="relatedBackgrounds.items.length"
            :class="{ active: relatedTabName === RELATED_TAB_BACKGROUNDS, hidden: !relatedPanelMenuExpanded && relatedTabName != RELATED_TAB_BACKGROUNDS && !isPortrait }"
            @click="chooseRelatedTab(RELATED_TAB_BACKGROUNDS)"
          )
            span Backgrounds
            .expand-menu-button(
              v-if="isMobile && !relatedPanelMenuExpanded && !isPortrait"
              v-html="$icons.menuArrowDown"
            )
        .panel-list(v-app-scroll ref="scrollContainer")
          masonry(
            :cols="panelColumnsCount"
            gutter="4"
            ref="masonry"
          )
            .item(
              v-for="item in getRelatedItems(relatedTabName)"
              :key="item.id"
              @click="selectRelatedToStage(item)"
              :style="getItemStyle(item)"
            )
              .hover(v-if="!isMobile")
                .icon.larger(v-html="relatedTabName === RELATED_TAB_BACKGROUNDS ? $icons.replace : $icons.plus")
                div {{ relatedTabName === RELATED_TAB_BACKGROUNDS ? 'Replace' : 'Add' }}
              img(:src="item.thumb")
          .load-button(v-show="showLoadButton")
            .background
            .text Load more
          .loader-container(v-show="itemsLoading")
            .loader
      .close-button(
        v-if="isMobile"
        v-html="$icons.close"
        @click="relatedToStagePanelExpanded = false"
      ) &times;
  .expand-button.rotate-180(
    v-if="!isMobile && isShowExpander"
    v-tooltip:top="'Expand panel'"
    v-html="$icons.menuArrowDown"
    @click="expandPanel()"
  )
  .mobile-expand-button(
    v-if="isMobile"
    :class="{ 'double-action': relatedItemsListShown }"
    ref="mobileExpandButton"
  )
    .button-corner(v-html="$icons.buttonCornerLeft")
    .button-icons
      .icon.rotate-180(
        v-if="(isShowExpander || !relatedItemsListShown)"
        v-html="$icons.menuArrowDown"
      )
      .icon(
        v-if="relatedItemsListShown"
        v-html="$icons.menuArrowDown"
      )
    .button-corner.right(v-html="$icons.buttonCornerRight")
</template>

<script>
import { mapState, mapActions } from 'vuex'
import config from '../config'
import photosApi from '../api/photos'
import storeService from '../services/store'
import stageService from '../services/stage'
import itemsService from '../services/items/common'
import backgroundService from '../services/items/background'
import modelService from '../services/items/model'
import objectService from '../services/items/object'
import ReplaceItemCommand from '../history/commands/replaceItem'
import AddItemCommand from '../history/commands/addItem'
import SwapFaceCommand from '../history/commands/swapFace'

const RELATED_TAB_MODELS = 'relatedModels'
const RELATED_TAB_OBJECTS = 'relatedObjects'
const RELATED_TAB_BACKGROUNDS = 'relatedBackgrounds'

export default {
  name: 'RelatedItems',
  data () {
    return {
      loading: true,
      loadingMore: false,
      preloadingItems: [],
      showLoadButton: false,
      itemsLoading: false,
      listWidth: 0,
      relatedToItemPanelExpanded: false,
      relatedToStagePanelExpanded: false,
      swappedFacesPanelExpanded: false,
      relatedPanelMenuExpanded: false,
      relatedPanelMenuIsSticky: false,
      stagePreview: null,
      RELATED_TAB_MODELS,
      RELATED_TAB_OBJECTS,
      RELATED_TAB_BACKGROUNDS,
      relatedTabName: RELATED_TAB_MODELS,
      mainListStyle: {},
      mainListItemStyles: {
        width: 'auto',
        'min-width': 'auto',
        height: 'auto',
        margin: '8 0'
      },
      panelColumnsCount: 0,
      mainListItemSizes: {
        width: 0,
        height: 0,
        margin: 4
      },
      swipe: {
        direction: null,
        startX: null,
        startY: null,
        distanceX: null,
        distanceY: null,
        threshold: 25, // required min distance traveled to be considered swipe
        restraint: 80, // maximum distance allowed at the same time in perpendicular direction
        allowedTime: 300, // maximum time allowed to travel that distance
        elapsedTime: null,
        startTime: null
      },
      entity: RELATED_TAB_MODELS
    }
  },
  computed: {
    ...mapState({
      backgrounds: state => {
        const actualSizesAndPosition = stageService.getActualSizesAndPosition()
        const stageAspectRatio = actualSizesAndPosition.width / actualSizesAndPosition.height
        const backgrounds = [...state.editor.backgrounds.items]

        backgrounds.forEach(background => {
          background.aspectRatio = Math.abs(stageAspectRatio - background.width / background.height)
        })

        return backgrounds.sort((a, b) => a.aspectRatio - b.aspectRatio)
      },
      isDefaultBackgroundActive: state => state.editor.isDefaultBackgroundActive,
      isMobile: state => state.editor.isMobile,
      isPortrait: state => state.editor.isPortrait,
      relatedItemsListShown: state => state.editor.related.itemsListShown,
      relatedModels: state => state.editor.related.models,
      relatedObjects: state => state.editor.related.objects,
      relatedBackgrounds: state => state.editor.related.backgrounds,
      relatedToItemItems: state => state.editor.related.toItemItems,
      relatedToStageItems: state => state.editor.related.toStageItems.items,
      relatedToStageLoading: state => state.editor.related.toStageItems.loading,
      leftSidebarWidth: state => state.editor.leftSidebarWidth,
      activeItem: state => state.editor.activeItem,
      faceSelected: state => state.editor.faceSelected,
      isEmpty (state) {
        return (state.editor.activeItem && (!state.editor.related.toItemItems.items.length && !state.editor.activeItem.swappedFacesData)) ||
         (!state.editor.activeItem && !state.editor.related.toStageItems.items.length && !state.editor.isDefaultBackgroundActive)
      }
    }),
    isShowExpander () {
      let showExpander = false

      if (!this.isEmpty) {
        let itemsQuantity

        if (this.$el && this.activeItem && this.faceSelected && this.activeItem.swappedFacesData) {
          itemsQuantity = this.activeItem.swappedFacesData.faces.length
        } else if (this.$el && this.activeItem && this.relatedToItemItems.items.length) {
          itemsQuantity = this.relatedToItemItems.items.length
        } else if (this.$el && !this.activeItem && this.relatedToStageItems.length) {
          itemsQuantity = this.relatedToStageItems.length
        } else if (this.$el && !this.activeItem && this.isDefaultBackgroundActive) {
          itemsQuantity = this.backgrounds.length
        }

        const itemsWidth = (this.mainListItemSizes.width + 2 * this.mainListItemSizes.margin) * itemsQuantity
        if (this.$el && itemsWidth > this.$el.offsetWidth) {
          showExpander = true
        }
      }

      return showExpander
    }
  },
  watch: {
    activeItem (newVal, oldVal) {
      storeService.get('vuex').commit('setDefaultBackgroundActive', false)
      this.setRelatedToItemItems({ items: [], total: 0, page: 0 })

      if (newVal !== oldVal && newVal && [itemsService.TYPE_MODEL, itemsService.TYPE_OBJECT, itemsService.TYPE_BACKGROUND].includes(newVal.type)) {
        const activeItem = storeService.get('activeItem')
        if (this.faceSelected) {
          this.loading = false
          this.entity = `swappedFaces`
        } else {
          const activeItemObjectData = activeItem.getAttrs().objectData

          this.loading = true
          this.entity = `alternative${activeItemObjectData.type.charAt(0).toUpperCase() + activeItemObjectData.type.slice(1)}s`

          this.startLoadingItems()
            .then(() => {
              this.loading = false
            })
        }
      }
    },
    relatedToStageLoading () {
      this.loading = this.relatedToStageLoading
    },
    leftSidebarWidth () {
      this.calculatePanelColumnsCount()
    },
    isMobile () {
      this.calculateStyles()
      if (this.isMobile) {
        this.$nextTick(() => this.attachExpanderSwipeEvents())
        this.$store.dispatch('setRelatedItemsListShown', false)
      } else {
        this.$store.dispatch('setRelatedItemsListShown', true)
      }
    },
    isPortrait () {
      this.relatedPanelMenuExpanded = false
    }
  },
  mounted () {
    this.mainListItemStyles.margin = this.isMobile ? 2 : 4
    this.calculateStyles()
    this.calculatePanelColumnsCount()
    this.generatePreloaderItems()
    window.addEventListener('resize', this.calculatePanelColumnsCount)
    if (this.isMobile) {
      this.attachExpanderSwipeEvents()
      this.$store.dispatch('setRelatedItemsListShown', false)
    } else {
      this.$store.dispatch('setRelatedItemsListShown', true)
    }
  },
  updated () {
    if (this.$refs.scrollContainer) {
      const scrollElement = this.$refs.scrollContainer.SimpleBar.getScrollElement()
      scrollElement.removeEventListener('scroll', this.scrollHandler)
      scrollElement.addEventListener('scroll', this.scrollHandler)
    }
    this.calculatePanelColumnsCount()
  },
  destroyed () {
    window.removeEventListener('resize', this.calculatePanelColumnsCount)
  },
  methods: {
    ...mapActions([
      'setRelatedToItemItems'
    ]),
    expandPanel () {
      if (this.activeItem && this.faceSelected && this.activeItem.swappedFacesData) {
        this.expandSwappedFacesPanel()
      } else if (this.activeItem || this.isDefaultBackgroundActive) {
        this.expandRelatedToItemPanel()
      } else {
        this.expandRelatedToStagePanel()
      }
    },
    swapFace (face) {
      storeService.get('commandManager').execute(new SwapFaceCommand(storeService.get('activeItem'), face))
        .then(() => {
          this.stagePreview = stageService.getStagePreview(storeService.get('activeItem'))
        })
    },
    swapRandomFace () {
      this.swapFace(this.activeItem.swappedFacesData.faces[Math.floor(Math.random() * (this.activeItem.swappedFacesData.faces.length - 0)) + 0])
    },
    attachExpanderSwipeEvents () {
      this.$refs.mobileExpandButton.addEventListener('touchstart', this.handleTouchStart)
      this.$refs.mobileExpandButton.addEventListener('touchmove', this.handleTouchMove)
      this.$refs.mobileExpandButton.addEventListener('touchend', this.handleTouchEnd)
    },
    handleTouchStart (event) {
      const touchobj = event.changedTouches[0]
      this.swipe.direction = 'none'
      this.swipe.startX = touchobj.pageX
      this.swipe.startY = touchobj.pageY
      this.swipe.startTime = new Date().getTime() // record time when finger first makes contact with surface
      event.preventDefault()
    },
    handleTouchMove (event) {
      event.preventDefault() // prevent scrolling when inside DIV
    },
    handleTouchEnd (event, item) {
      const touchobj = event.changedTouches[0]
      let isClick = false
      this.swipe.distanceX = touchobj.pageX - this.swipe.startX // get horizontal dist traveled by finger while in contact with surface
      this.swipe.distanceY = touchobj.pageY - this.swipe.startY // get vertical dist traveled by finger while in contact with surface
      this.swipe.elapsedTime = new Date().getTime() - this.swipe.startTime // get time elapsed

      // If click
      if (
        (Math.abs(this.swipe.distanceX) <= this.swipe.threshold && Math.abs(this.swipe.distanceY) <= this.swipe.restraint) ||
          (Math.abs(this.swipe.distanceY) <= this.swipe.threshold && Math.abs(this.swipe.distanceX) <= this.swipe.restraint)
      ) {
        isClick = true
      }

      // If swipe
      if (!isClick && this.swipe.elapsedTime <= this.swipe.allowedTime) { // first condition for swipe met
        if (Math.abs(this.swipe.distanceX) >= this.swipe.threshold && Math.abs(this.swipe.distanceY) <= this.swipe.restraint) { // 2nd condition for horizontal swipe met
          this.swipe.direction = (this.swipe.distanceX < 0) ? 'left' : 'right' // if dist traveled is negative, it indicates left swipe
        } else if (Math.abs(this.swipe.distanceY) >= this.swipe.threshold && Math.abs(this.swipe.distanceX) <= this.swipe.restraint) { // 2nd condition for vertical swipe met
          this.swipe.direction = (this.swipe.distanceY < 0) ? 'up' : 'down' // if dist traveled is negative, it indicates up swipe
        }
      }

      if (isClick && item) {
        if (this.activeItem) {
          this.selectRelatedToStage(item)
        } else {
          this.selectRelatedToItem(item)
        }
      } else if (this.swipe.direction === 'up') { // If upper swipe detected - expand panel
        if (!this.relatedItemsListShown) {
          this.$store.dispatch('setRelatedItemsListShown', true)
        } else {
          this.expandPanel()
        }
      } else if (this.swipe.direction === 'down') { // If down swipe detected - collapse panel
        this.$store.dispatch('setRelatedItemsListShown', false)
      }
      event.preventDefault()
    },
    calculateStyles () {
      this.mainListItemSizes.margin = this.isMobile ? 2 : 4
      const listHeight = this.isMobile ? config.relatedPanel.mobileHeight : config.relatedPanel.desktopHeight
      const itemHeight = listHeight - this.mainListItemSizes.margin * 4
      this.$el.style.height = listHeight
      this.mainListItemSizes.width = itemHeight * 1.5
      this.mainListItemSizes.height = itemHeight
      this.mainListItemStyles = {
        width: `${this.mainListItemSizes.width}px`,
        'min-width': `${this.mainListItemSizes.width}px`,
        height: `${this.mainListItemSizes.height}px`,
        margin: `${this.mainListItemSizes.margin * 2}px ${this.mainListItemSizes.margin}px`
      }
    },
    calculatePanelColumnsCount: function () {
      this.getListWidth()
      const columnsQuantity = Math.floor(this.listWidth / (this.isMobile ? 90 : 120))

      if (this.$refs.masonry) {
        this.$refs.masonry.displayColumns = columnsQuantity
      }

      this.panelColumnsCount = columnsQuantity
    },
    generatePreloaderItems () {
      for (let i = 0; i < 20; i++) {
        this.preloadingItems.push({
          'min-width': this.mainListItemStyles['min-width'],
          height: this.mainListItemStyles.height
        })
      }
    },
    shrinkRelatedToStagePanel () {
      this.relatedToStagePanelExpanded = false
      itemsService.loadStageItems()
    },
    expandSwappedFacesPanel () {
      this.swappedFacesPanelExpanded = true
      this.stagePreview = stageService.getStagePreview(storeService.get('activeItem'))
    },
    expandRelatedToItemPanel () {
      this.relatedToItemPanelExpanded = true
      this.stagePreview = stageService.getStagePreview(storeService.get('activeItem'))
    },
    expandRelatedToStagePanel () {
      this.relatedToStagePanelExpanded = true
      this.stagePreview = stageService.getStagePreview()
      this.entity = this.relatedTabName

      // Handle scroll to make menu sticky when menu is on the top of the screen
      this.$nextTick(() => {
        const relatedPanel = this.$refs.relatedPanel
        relatedPanel.onscroll = () => {
          this.relatedPanelMenuIsSticky = relatedPanel.scrollTop > 198
        }
      })
    },
    selectRelatedToStage (item) {
      storeService.get('vuex').commit('setDefaultBackgroundActive', false)
      storeService.get('commandManager').execute(new AddItemCommand(
        item,
        {},
        false,
        this.relatedToItemPanelExpanded || this.relatedToStagePanelExpanded)
      )
        .then(() => {
          this.stagePreview = stageService.getStagePreview()
        })
    },
    selectRelatedToItem (item) {
      if (item.type === itemsService.TYPE_BACKGROUND) {
        storeService.get('commandManager').execute(new AddItemCommand(item))
          .then(() => {
            this.stagePreview = stageService.getStagePreview(storeService.get('activeItem'))
          })
      } else {
        storeService.get('commandManager').execute(new ReplaceItemCommand(
          storeService.get('activeItem'),
          item,
          this.relatedToItemPanelExpanded || this.relatedToStagePanelExpanded
        ))
          .then(() => {
            this.stagePreview = stageService.getStagePreview(storeService.get('activeItem'))
          })
      }
    },
    chooseRelatedTab (relatedTabName) {
      if (this.isMobile && !this.relatedPanelMenuExpanded && !this.isPortrait) {
        this.relatedPanelMenuExpanded = true
      } else {
        this.relatedTabName = relatedTabName
        this.relatedPanelMenuExpanded = false
        this.entity = relatedTabName
      }
    },
    getRelatedItems (tabName) {
      let relatedItems

      switch (tabName) {
        case RELATED_TAB_MODELS:
          relatedItems = this.relatedModels.items
          break
        case RELATED_TAB_OBJECTS:
          relatedItems = this.relatedObjects.items
          break
        case RELATED_TAB_BACKGROUNDS:
          relatedItems = this.relatedBackgrounds.items
          break
      }

      return relatedItems
    },
    getItemStyle (item) {
      const guttersWidth = this.panelColumnsCount > 1 ? (this.panelColumnsCount - 1) * 4 : 0
      let width = (this.listWidth - guttersWidth) / this.panelColumnsCount
      let widthRatio = width / item.width
      let height = item.height * widthRatio

      // If picture is too tall
      if (height / width > config.itemMaxRatio) {
        height = width * config.itemMaxRatio
      }

      return { height: height + 'px' }
    },
    getListWidth () {
      let listPadding = 224
      if (this.isMobile) {
        listPadding = 32
      } else if (this.relatedToStagePanelExpanded) {
        listPadding = 280
      }

      this.listWidth = this.$el.offsetWidth - listPadding
    },
    dragStart (object, event) {
      event.dataTransfer.setData('text/plain', JSON.stringify(object))
    },
    scrollHandler () {
      const scrollElement = this.$refs.scrollContainer.SimpleBar.getScrollElement()
      if (scrollElement.scrollTop > this.$refs.masonry.$el.offsetHeight - this.$refs.scrollContainer.offsetHeight - 20) {
        // Check if all items are loaded
        if (this[this.relatedTabName].items.length < this[this.relatedTabName].total && this.relatedToStagePanelExpanded) {
          this.startLoadingItems()
        } else if (this.relatedToItemItems.items.length < this.relatedToItemItems.total && this.relatedToItemPanelExpanded) {
          this.startLoadingItems()
        } else if (this.activeItem && this.activeItem.swappedFacesData.faces.length < this.activeItem.swappedFacesData.total) {
          this.startLoadingItems()
        }
      }
    },
    startLoadingItems () {
      return new Promise(resolve => {
        if (!this.loadingMore) {
          this.loadingMore = true
          this.showLoadButton = false
          this.itemsLoading = true
          this.$nextTick(() => {
            this.loadItems()
              .then(() => {
                this.$nextTick(() => {
                  this.itemsLoading = false
                  this.loadingMore = false
                  resolve()
                })
              })
          })
        }
      })
    },
    loadItems () {
      return new Promise(resolve => {
        switch (this.entity) {
          case 'relatedBackgrounds':
            this.loadItemsByEntity('backgrounds', itemsService.loadRelatedBackgrounds, backgroundService.handlePhotos, resolve)
            break
          case 'relatedModels':
            this.loadItemsByEntity('models', itemsService.loadRelatedModels, modelService.handlePhotos, resolve)
            break
          case 'relatedObjects':
            this.loadItemsByEntity('objects', itemsService.loadRelatedObjects, objectService.handlePhotos, resolve)
            break
          case 'alternativeBackgrounds':
            this.loadItemsByEntity('backgrounds', photosApi.backgrounds, backgroundService.handlePhotos, resolve, 'alternative')
            break
          case 'alternativeModels':
            this.loadItemsByEntity('models', photosApi.models, modelService.handlePhotos, resolve, 'alternative')
            break
          case 'alternativeObjects':
            this.loadItemsByEntity('objects', photosApi.objects, objectService.handlePhotos, resolve, 'alternative')
            break
          case 'swappedFaces':
            this.loadSwappedFaces(resolve)
            break
        }
      })
    },
    loadItemsByEntity (initEntity, loadItemsFunction, handlePhotosFunction, resolve, store = 'related') {
      let page = this[this.relatedTabName].page + 1
      let params = { page }

      if (store === 'alternative') {
        const activeItemObjectData = storeService.get('activeItem').getAttrs().objectData

        params[`related_${activeItemObjectData.type}_id`] = activeItemObjectData.id
        params.page = this.relatedToItemItems.page + 1
        page = params.page

        return loadItemsFunction(params)
          .then(response => {
            const items = handlePhotosFunction(response[initEntity], true, store)
            this.$store.dispatch(`setRelatedToItemItems`, { items, total: response.total, page })
            resolve()
          })
      }

      loadItemsFunction(true, params)
        .then(response => {
          resolve()
        })
    },
    loadSwappedFaces (resolve) {
      const activeItem = storeService.get('activeItem')
      const objectData = activeItem.getAttrs().objectData
      if (activeItem && objectData.swappedFacesData) {
        const page = objectData.swappedFacesData.page + 1
        photosApi.getSwappedFacesByModel(objectData.id, { page })
          .then(faces => {
            if (faces.total) {
              this.$store.dispatch('elementSelected', null)
              objectData.swappedFacesData = {
                faces: [...objectData.swappedFacesData.faces, ...faces.swappedFaces],
                total: faces.total,
                page
              }
              this.$store.dispatch('elementSelected', objectData)
            }
            resolve()
          })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../assets/css/mixins';
@import '../assets/css/effects';

$background: #1a1a1a;

.related-items {
  width: 100%;
  height: 100%;
  position: relative;
  padding-left: 4px;
  border-top: 1px solid rgba(255, 255, 255, 0.05);
  background: $background;

  .preloader-items {
    flex-wrap: nowrap;
    position: relative;
    z-index: 20;

    .animated-background {
      margin: 0 4px;
      border-radius: 6px;
    }
  }

  .list {
    width: 100%;
    display: flex;
    position: absolute;
    z-index: 20;
    padding: 0;

    .item {
      display: flex;
      align-items: center;
      justify-content: center;
      background-color: #fff;
      overflow: hidden;
      border-radius: 6px;
      cursor: pointer;

      &>img {
        height: 100%;
      }

      &.random-face {
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: center;
        background-color: rgba(255, 255, 255, 0.1);
        color: #fff;
        font-size: 14px;

        .icon {
          width: 24px;
          height: 24px;
        }
      }

      &.swapped-face {
        &>img {
          width: 100%;
          height: auto;
        }
      }
    }
  }

  &:hover {
    background-color: #252525;

    .expand-button {
      opacity: 1;
      @include delay();
    }
  }

  .panel {
    width: calc(100% + 6px);
    height: 100vh;
    height: calc(var(--vh, 1vh) * 100);
    transition: 0.5s;
    position: absolute;
    bottom: 0;
    left: -6px;
    background-color: $background;
    z-index: 20;

    .stage {
      width: 100%;
      height: 198px;
      position: relative;
      display: flex;
      align-items: center;
      justify-content: center;
      padding: 24px 0 40px 0;

      .title {
        position: absolute;
        top: 0;
        left: 0;
        font-size: 24px;
        text-transform: uppercase;
        color: #fff;
        padding: 16px 0 0 24px;
        font-weight: bold;
      }

      .snapshot {
        position: relative;
        height: 100%;

        img {
          height:100%;
          object-fit: contain;
        }

        .shrink-button {
          width: 44px;
          height: 44px;
          top: calc(50% - 22px);
          right: -84px;
          position: absolute;
          background-color: #1a1a1a;
          border-radius: 50px;
          border: 1px solid #262626;
          fill: #fff;
          padding: 10px;
          cursor: pointer;
        }
      }
    }

    .loader-container {
      position: absolute;
      display: flex;
      justify-content: center;
      background-color: #000;
      bottom: 0;
      left: 0;
      width: 100%;
      opacity: 0.5;

      .loader {
        height: 56px;
        position: relative;
        @include loading(#fff, 4px, 32px);
      }
    }

    .list-container {
      padding: 0 112px;
      width: 100%;
      height: calc(100% - 192px);

      .panel-list {
        display: flex;
        width: 100%;
        height: 100%;

        .item {
          margin-bottom: 4px;
          overflow: hidden;
          background-color: #f8f4ed;
          border-radius: 6px;
          cursor: pointer;

          &>img {
            object-fit: contain;
            width: 100%;
            height: 100%;
          }

          &.swapped-face {
            height: 150px;

            &>img {
              object-fit: cover;
              width: 100%;
            }
          }
        }
      }
    }

    .load-button {
      position: absolute;
      bottom: 0;
      left: 0;
      width: 100%;
      height: 35px;
      cursor: pointer;

      .background {
        opacity: 0.4;
        background-color: #000;
        width: 100%;
        height: 100%;
      }

      .text {
        width: 100%;
        height: 100%;
        position: absolute;
        top: 5px;
        text-align: center;
      }

      &:hover {
        .background {
          opacity: 0.5;
        }
      }
    }
  }

  .related-panel {
    .list-container {
      padding: 0 140px 0 0;
      display: flex;
      width: 100%;
      flex-direction: row;
    }

    .menu {
      min-width: 140px;
      margin-top: -16px;
      color: rgba(255, 255, 255, 0.5);

      &-item {
        padding: 16px 0 16px 24px;
        font-size: 14px;
        cursor: pointer;

        &:hover, &.active {
          color: #fff;
          @include delay()
        }
      }
    }
  }

  .item {
    position: relative;

    .hover {
      display: none;
      width: 100%;
      height: 100%;
      position: absolute;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      color: #fff;
      background-color: rgba(0, 0, 0, 0.5);

      .icon {
        width: 22px;
        height: 22px;
        margin-bottom: 8px;
        fill: #fff;

        &.larger {
          width: 32px;
          height: 32px;
        }
      }
    }

    &:hover .hover {
      display: flex;
    }
  }

  .expand-button {
    position: absolute;
    opacity: 0;
    width: 54px;
    height: 27px;
    top: -28px;
    left: calc(50% - 25px);
    background-color: #252525;
    border-radius: 50px 50px 0 0;
    fill: #fff;
    padding: 5px 15px 0 15px;
    cursor: pointer;
    @include delay();
  }

  &.mobile {
    .list {
      .item {
        &.random-face {
          font-size: 10px;
        }
      }
    }

    .stage {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      padding: 16px 0 24px 0;

      .title {
        width: 100%;
        position: relative;
        text-align: center;
        padding: 0 0 16px 0;
      }

      .snapshot {
        display: flex;
        height: auto;
        flex: 1;
        align-items: center;
        justify-content: center;
      }
    }

    .list-container {
      padding: 0 16px;
    }

    .panel {
      width: 100%;
      left: 0;
    }

    .related-panel {
      .list-container {
        flex-direction: column;

        .panel-list {
          height: calc(100% - 72px);
        }
      }

      .menu {
        display: flex;
        flex-direction: column;
        align-items: center;
        position: relative;
        overflow: hidden;
        margin: 0 0 24px 0;

        &.expanded {
          height: 126px;
          min-height: 126px;
          @include delay()
        }

        &.shrinked, &.portrait {
          height: 42px;
          min-height: 42px;
          @include delay()
        }

        .expand-menu-button {
          width: 13px;
          height: 10px;
          margin-left: 8px;
          fill: #fff;
        }

        .menu-item {
          width: 100%;
          display: flex;
          flex-direction: row;
          align-items: center;
          justify-content: center;
          padding: 10px 0;
          text-align: center;
          border-bottom: 1px solid rgba(255, 255, 255, 0.1);

          &.hidden {
            display: none;
          }
        }
      }
    }

    .mobile-expand-button {
      width: 54px;
      height: 27px;
      display: flex;
      flex-direction: row;
      align-items: flex-end;
      justify-content: space-between;
      position: absolute;
      top: -28px;
      left: calc(50% - 25px);
      background-color: #252525;
      border-radius: 16px 16px 0 0;
      fill: #fff;
      cursor: pointer;
      @include delay();

      .button-icons {
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: center;

        .icon {
          width: 20px;
          height: 20px;
        }
      }

      .button-corner {
        width: 7px;
        height: 6px;
        margin-left: -7px;

        &.right {
          position: relative;
          right: -7px;
        }
      }

      &.double-action .icon {
        width: 12px;
        height: 12px;
      }
    }
  }

  &.portrait {
    &.mobile {
      .panel {
        overflow: auto;

        .list-container {
          height: auto;
        }
      }

      .menu {
        flex-direction: row;
        padding: 0 64px;
        border-bottom: 1px solid rgba(255, 255, 255, 0.1);

        &.sticky {
          width: calc(100% - 32px);
          height: 52px;
          position: fixed;
          z-index: 20;
          top: 0;
          left: 16px;
          background-color: $background;
          border-bottom: none;
        }

        .menu-item {
          width: 33.333%;
          border-bottom: none;
        }
      }
    }
  }

  .close-button {
    position: fixed;
    z-index: 30;
  }
}
</style>
